misc minor fixes
[distro-setup] / brc
1 #!/bin/bash
2 # Copyright (C) 2019 Ian Kelling
3 # SPDX-License-Identifier: AGPL-3.0-or-later
4 # this gets sourced. shebang is just for file mode detection
5
6 # Use source ~/.bashrc instead of doing bash -l when running a script
7 # so this can set extdebug and avoid the bash debugger.
8 if [[ -s /a/bin/errhandle/err ]]; then
9 source /a/bin/errhandle/err
10 elif [[ -s $bashrc_dir/err ]]; then
11 # shellcheck source=/a/bin/errhandle/err
12 source $bashrc_dir/err
13 fi
14
15 # In t8, it runs clear_console for login shells by default. I don't want
16 # my console cleared. And linux ttys get cleared without this.
17 if shopt login_shell >/dev/null && [[ -e ~/.bash_logout ]]; then
18 rm ~/.bash_logout
19 fi
20
21 # if [[ -s /usr/share/bash-completion/completions/git ]]; then
22 # source /usr/share/bash-completion/completions/git
23 # fi
24 # if [[ -s /usr/share/bash-completion/completions/gitk ]]; then
25 # source /usr/share/bash-completion/completions/gitk
26 # fi
27
28 # for testing error catching:
29 # t2() {
30 # echo t2
31 # grep sdf sdfd
32 # echo wtf
33 # }
34 # t1() {
35 # echo t1
36 # t2 a b c
37 # }
38
39 # * settings
40
41 CDPATH=.
42
43
44 # remove all aliases. aliases provided by the system tend to get in the way,
45 # for example, error happens if I try to define a function the same name as an alias
46 unalias -a
47
48 # remove gnome keyring warning messages
49 # there is probably a more proper way, but I didnt find any easily on google
50 # now using xfce+xmonad instead of vanilla xmonad, so disabling this
51 #unset GNOME_KEYRING_CONTROL
52
53 # use extra globing features.
54 shopt -s extglob
55 # include .files when globbing, but ignore files name . and ..
56 # setting this also sets dotglob.
57 export GLOBIGNORE="*/.:*/.."
58
59 # Useful info. see man bash.
60 PS4='$LINENO+ '
61
62
63 # broken with bash_completion package. Saw a bug for this once. dont anymore.
64 # still broken in wheezy
65 # still buggered in latest stable from the web, version 2.1
66 # perhaps its fixed in newer git version, which fails to make for me
67 # this note is from 6-2014.
68 # still broken in flidas.
69 #shopt -s nullglob
70
71 # make tab on an empty line do nothing
72 shopt -s no_empty_cmd_completion
73
74 # fix spelling errors for cd, only in interactive shell
75 shopt -s cdspell
76 # append history instead of overwritting it
77 shopt -s histappend
78 # for compatibility, per gentoo/debian bashrc
79 shopt -s checkwinsize
80 # attempt to save multiline single commands as single history entries.
81 shopt -s cmdhist
82 # enable **
83 shopt -s globstar
84
85
86 # inside emacs fixes
87 if [[ $LC_INSIDE_EMACS ]]; then
88 # EMACS is used by bash on startup, but we dont need it anymore.
89 # plus I hit a bug in a makefile which inherited it
90 unset EMACS
91 export LC_INSIDE_EMACS
92 export PAGER=cat
93 export MANPAGER=cat
94 # scp completion does not work, but this doesnt fix it. todo, figure this out
95 #complete -r scp &> /dev/null
96 # todo, remote file completion fails, figure out how to turn it off
97 export NODE_DISABLE_COLORS=1
98 # This gets rid of ugly terminal escape chars in node repl
99 # sometime, Id like to have completion working in emacs shell for node
100 # the offending chars can be found in lib/readline.js,
101 # things that do like:
102 # stream.write('\x1b[' + (x + 1) + 'G');
103 # We can remove them and keep readline, for example by doing this
104 # to start a repl:
105 #!/usr/bin/env nodejs
106 # var readline = require('readline');
107 # readline.cursorTo = function(a,b,c) {};
108 # readline.clearScreenDown = function(a) {};
109 # const repl = require('repl');
110 # var replServer = repl.start('');
111 #
112 # no prompt, or else readline complete seems to be confused, based
113 # on our column being different? node probably needs to send
114 # different kind of escape sequence that is not ugly. Anyways,
115 # completion doesnt work yet even with the ugly prompt, so whatever
116 #
117 export NODE_NO_READLINE=1
118
119 fi
120
121 export SSH_CONFIG_FILE_OVERRIDE=/root/.ssh/confighome
122
123 # emacs has a different default search path than the info command. This
124 # adds the info defaults to emacs, but not the reverse, because I dun
125 # care much about the cli. The search path is only on the cli if you run
126 # "info xxx", or in emacs if you run '(info xxx)', so not that
127 # important, but might as well fix it.
128
129 # info info says this path is what was compiled, and its not documented
130 # anywhere. Through source grepping, i found it in filesys.h of the info
131 # source in trisquel flidas.
132 #
133 # Traling : means for emacs to add its own stuff on to the end.
134
135 export INFOPATH=$PATH:/usr/local/info:/usr/info:/usr/local/lib/info:/usr/lib/info:/usr/local/gnu/info:/usr/local/gnu/lib/info:/usr/gnu/info:/usr/gnu/lib/info:/opt/gnu/info:/usr/share/info:/usr/share/lib/info:/usr/local/share/info:/usr/local/share/lib/info:/usr/gnu/lib/emacs/info:/usr/local/gnu/lib/emacs/info:/usr/local/lib/emacs/info:/usr/local/emacs/info:.:
136
137 # for openwrt system that has no stty, this is easier than
138 # guarding every time i use it.
139 if ! type -p stty >/dev/null; then
140 stty() { :; }
141 fi
142
143
144 use_color=false
145 if [[ $- == *i* ]]; then
146 # for readline-complete.el
147 if [[ $LC_INSIDE_EMACS ]]; then
148 # all for readline-complete.el
149 stty echo
150 bind 'set horizontal-scroll-mode on'
151 bind 'set print-completions-horizontally on'
152 bind '"\C-i": self-insert'
153 else
154
155
156 if [[ $TERM != dumb ]] && test -t 1; then
157 use_color=true
158 fi
159
160 if [[ $KONSOLE_PROFILE_NAME ]]; then
161 TERM=xterm-256color
162 fi
163
164 if [[ $TERM == alacritty && ! -e /usr/share/terminfo/a/alacritty ]]; then
165 # todo: we should try installing the alacritty terminfo if it is not found
166 # https://github.com/alacritty/alacritty/issues/2838
167 TERM=xterm-256color
168 fi
169
170 # copying from the alacritty example above,
171 if [[ $TERM == xterm-kitty ]]; then
172 if [[ ! -e /usr/share/terminfo/x/xterm-kitty ]]; then
173 TERM=xterm-256color
174 else
175 if [[ -e /a/opt/kitty/shell-integration/bash/kitty.bash ]]; then
176 KITTY_SHELL_INTEGRATION=t
177 source /a/opt/kitty/shell-integration/bash/kitty.bash
178 fi
179 fi
180 fi
181
182 # todo: not sure this works in sakura
183 #stty werase undef
184 #bind "\C-w": kill-region
185 # sakura == xterm-256color
186 # konsole == xterm
187 if [[ $TERM != xterm-kitty && $TERM == xterm* ]]; then
188 # control + arrow keys. for other terminals, see http://unix.stackexchange.com/questions/10806/how-to-change-previous-next-word-shortcut-in-bash
189 bind '"\e[1;5C": shell-forward-word' 2>/dev/null
190 bind '"\e[1;5D": shell-backward-word' 2>/dev/null
191 else
192 # make ctrl-backspace work. for konsole, i fixed it through
193 # /home/iank/.local/share/konsole/default.keytab
194 stty werase ^h
195 bind '"\eOc": shell-forward-word'
196 bind '"\eOd": shell-backward-word'
197 fi
198 # i cant remember why i did this, probably to free up some keys to bind
199 # to other things in bash.
200 # other than C-c and C-z, the rest defined by stty -a are, at least in
201 # gnome-terminal, overridden by bash, or disabled by the system
202 stty lnext undef stop undef start undef
203 fi
204
205 fi
206
207 case $TERM in
208 # fixup broken backspace in chroots
209 xterm-kitty|alacritty)
210 chroot() {
211 TERM=xterm-256color command chroot "$@"
212 }
213 ;;
214 esac
215
216 export BC_LINE_LENGTH=0
217
218 # ansible option
219 export PROFILE_TASKS_TASK_OUTPUT_LIMIT=100
220
221 # note, if I use a machine I dont want files readable by all users, set
222 # umask 077 # If fewer than 4 digits are entered, leading zeros are assumed
223
224 # i for insensitive. the rest from
225 # X means dont remove the current screenworth of output upon exit
226 # R means to show colors n things
227 export LESS=RXij12
228 export SYSTEMD_LESS=$LESS
229
230 export NNN_COLORS=2136
231
232 export SL_FILES_DIR=/b/ds/sl/.iank
233 export SL_INFO_DIR=/p/sshinfo
234
235
236 # * include files
237
238 if [[ -s $bashrc_dir/path-add-function ]]; then
239 source $bashrc_dir/path-add-function
240 if [[ $SSH_CLIENT ]]; then
241 if grep -qF /home/iank/.iank/e/e /etc/exports &>/dev/null; then
242 export EMACSDIR=/home/iank/.iank/e/e
243 fi
244 path-add $bashrc_dir
245 fi
246 fi
247
248 # if someone exported $SOE (stop on error), catch errors.
249 #
250 # Note, on debian this results in the following warning when in ssh,
251 # hich I haven't figured out how to fix. It doesn't happen if we source
252 # after the shell has started
253 #
254 # bash: /usr/share/bashdb/bashdb-main.inc: No such file or directory
255 # bash: warning: cannot start debugger; debugging mode disabled
256 if [[ $SOE ]]; then
257 if [[ -e /a/bin/errhandle/err ]]; then
258 source /a/bin/errhandle/err
259 fi
260 fi
261
262
263 mysrc() {
264 local path dir file
265 path=$1
266 dir=${path%/*}
267 file=${path##*/}
268 if [[ -s $path ]]; then
269 source $path
270 elif [[ -s $bashrc_dir/$file ]]; then
271 source $bashrc_dir/$file
272 fi
273 }
274
275
276 mysrc /a/bin/small-misc-bash/ll-function
277 mysrc /a/bin/distro-functions/src/package-manager-abstractions
278
279
280 # * functions
281 ccomp() { # copy completion
282 local src=$1
283 local c
284 shift
285 if ! c=$(complete -p $src 2>/dev/null); then
286 _completion_loader $src &>/dev/null ||:
287 c=$(complete -p $src 2>/dev/null) || return 0
288 fi
289 # remove $src( .*|$)
290 c=${c% $src}
291 c=${c%% $src *}
292 eval $c $*
293 }
294
295
296 ..() { c ..; }
297 ...() { c ../..; }
298 ....() { c ../../..; }
299 .....() { c ../../../..; }
300 ......() { c ../../../../..; }
301
302 chere() {
303 local f path
304 for f; do
305 path=$(readlink -e "$f")
306 echo "cat >$path <<'EOF'"
307 cat "$f"
308 echo EOF
309 done
310 }
311
312
313 # file cut copy and paste, like the text buffers :)
314 # I havnt tested these.
315 _fbufferinit() { # internal use
316 ! [[ $my_f_tempdir ]] && my_f_tempdir=$(mktemp -d)
317 rm -rf "${my_f_tempdir:?}"/*
318 }
319 fcp() { # file cp
320 _fbufferinit
321 cp "$@" "$my_f_tempdir"/
322 }
323 fct() { # file cut
324 _fbufferinit
325 mv "$@" "$my_f_tempdir"/
326 }
327 fpst() { # file paste
328 [[ $2 ]] && { echo too many arguments; return 1; }
329 target=${1:-.}
330 cp "$my_f_tempdir"/* "$target"
331 }
332
333 _khfix_common() {
334 local host ip port file key
335 read -r host ip port < <(timeout -s 9 2 ssh -oBatchMode=yes -oControlMaster=no -oControlPath=/ -v $1 |& sed -rn "s/debug1: Connecting to ([^ ]+) \[([^\]*)] port ([0-9]+).*/\1 \2 \3/p" ||: )
336 file=$(readlink -f ~/.ssh/known_hosts)
337 if [[ ! $ip ]]; then
338 echo "khfix: ssh failed"
339 return 1
340 fi
341 if [[ $port != 22 ]]; then
342 ip_entry="[$ip]:$port"
343 host_entry="[$host]:$port"
344 else
345 ip_entry=$ip
346 host_entry=$host
347 fi
348 tmpfile=$(mktemp)
349 if [[ $host != $ip ]]; then
350 key=$(ssh-keygen -F "$host_entry" -f $file | sed -r 's/^.*([^ ]+ +[^ ]+) *$/\1/')
351 if [[ $key ]]; then
352 grep -Fv "$key" "$file" | sponge "$file"
353 fi
354 fi
355 key=$(ssh-keygen -F "$ip_entry" -f $file | sed -r 's/^.*([^ ]+ +[^ ]+) *$/\1/')
356 if [[ $key ]]; then
357 grep -Fv "$key" "$file" | sponge "$file"
358 fi
359 ll ~/.ssh/known_hosts
360 rootsshsync
361 }
362 khfix() { # known hosts fix
363 _khfix_common "$@" || return 1
364 ssh $1 :
365 }
366 khcopy() {
367 _khfix_common "$@"
368 ssh-copy-id $1
369 }
370
371 a() {
372 local x
373 x=$(readlink -nf "${1:-$PWD}")
374 # yes, its kinda dumb that xclip/xsel cant do this in one invocation
375 echo -n "$x" | xclip -selection clipboard
376 echo -n "$x" | xclip
377 }
378
379 # a1 = awk {print $1}
380 for field in {1..20}; do
381 eval a$field"() { awk '{print \$$field}'; }"
382 done
383 # h1 = head -n1
384 for num in {1..9}; do
385 eval h$num"() { head -n$num; }"
386 done
387
388
389 hexipv4() {
390 printf '%d.%d.%d.%d\n' $(echo $1 | sed 's/../0x& /g')
391 }
392
393 vp9() {
394 local f out outdir in
395 outdir=vp9
396 case $1 in
397 --out)
398 outdir=$2
399 shift 2
400 ;;
401 esac
402 m mkdir -p $outdir
403 for f; do
404 out=$PWD/$outdir/$f
405 in=$PWD/$f
406 m cd $(mktemp -d)
407 pwd
408 m ffmpeg -threads 0 -i $in -g 192 -vcodec libvpx-vp9 -vf scale=-1:720 -max_muxing_queue_size 9999 -b:v 750K -pass 1 -an -f null /dev/null
409 m ffmpeg -y -threads 0 -i $in -g 192 -vcodec libvpx-vp9 -vf scale=-1:720 -max_muxing_queue_size 9999 -b:v 750K -pass 2 -c:a libvorbis -qscale:a 5 $out
410 cd -
411 done
412 }
413
414 utcl() { # utc 24 hour time to local hour 24 hour time
415 echo "print( ($1 $(date +%z | sed -r 's/..$//;s/^(-?)0*/\1/')) % 24)"|python3
416 }
417
418 declare -a _iankdirf _iankdirb
419
420
421 # ## old wcd, to be deleted
422 # b() {
423 # # backwards
424 # c -
425 # }
426 # # shellcheck disable=SC2032
427 # f() {
428 # # cd forward
429 # c +
430 # }
431 # cl() {
432 # # choose recent directory. cl = cd list
433 # c =
434 # }
435 # # c. better cd
436 # if ! type -t c &>/dev/null; then
437 # if type -p wcd &>/dev/null; then
438 # if [[ $LC_INSIDE_EMACS ]]; then
439 # c() { wcd -c -z 50 -o "$@"; }
440 # else
441 # # lets see what the fancy terminal does from time to time
442 # c() { wcd -c -z 50 "$@"; }
443 # fi
444 # else
445 # c() { cd "$@"; }
446 # fi
447 # fi
448
449 # c. better cd.
450 # keep 2 stacks, forward and back. the top of the back is $PWD
451 # as long as the last directory change was due to c,b,or cl.
452 c() {
453 # normally, the top of dirb is our current dir. if it isn't,
454 # put it on there, except we don't want to do that when we
455 # just launched a shell
456 if [[ $OLDPWD ]]; then
457 if (( ${#_iankdirb[@]} == 0 )) || [[ ${_iankdirb[-1]} != "$PWD" ]]; then
458 _iankdirb+=("$PWD")
459 fi
460 fi
461 cd "$@"
462 if (( ${#_iankdirb[@]} == 0 )) || [[ ${_iankdirb[-1]} != "$PWD" ]]; then
463 _iankdirb+=("$PWD")
464 fi
465 echo "$PWD" >> ~/.iankdirs
466 }
467 ccomp cd c
468
469 b() {
470 local topb
471 if (( ${#_iankdirb[@]} == 0 )); then
472 echo "nothing left to go back to" >&2
473 return 0
474 fi
475 topb="${_iankdirb[-1]}"
476
477 if [[ $topb == "$PWD" ]] && (( ${#_iankdirb[@]} == 1 )); then
478 echo "already on last back entry" >&2
479 return 0
480 fi
481
482
483 if [[ $topb == "$PWD" ]]; then
484 # add to dirf if not already there
485 if (( ${#_iankdirf[@]} == 0 )) || [[ ${_iankdirf[-1]} != "$topb" ]]; then
486 _iankdirf+=("$topb")
487 fi
488 unset "_iankdirb[-1]"
489 cd "${_iankdirb[-1]}"
490 else
491 if (( ${#_iankdirf[@]} == 0 )) || [[ ${_iankdirf[-1]} != "$PWD" ]]; then
492 _iankdirf+=("$PWD")
493 fi
494 cd "$topb"
495 fi
496
497 # give us a peek at what is next in the list
498 # if (( ${#_iankdirb[@]} >= 2 )); then
499 # printf "%s\n" "${_iankdirb[-2]}"
500 # fi
501 }
502
503 f() {
504 local topf
505 if (( ${#_iankdirf[@]} == 0 )); then
506 echo "no forward dir left" >&2
507 return 0
508 fi
509 topf="${_iankdirf[-1]}"
510 unset "_iankdirf[-1]"
511 c "$topf"
512
513 # give us a peek at what is next in the list
514 # if (( ${#_iankdirf[@]} )); then
515 # printf "%s\n" "${_iankdirf[-1]}"
516 # fi
517 }
518
519 # a b c (d)
520 ## back
521 # a b (c)
522 # d
523 #back
524 #a (b)
525 #d c
526 #back
527 #(a)
528 #d c b
529 #forward
530 #a (b)
531 #d c
532 #
533 # a b c
534 ## back
535 # a b
536 # (c)
537 ## forward
538
539 cl() {
540 local i line input start tmpfile
541 local -A buttondirs alines
542 local -a buttons dirs lines
543 buttons=( {a..z} {2..9} )
544 if [[ ! -s ~/.iankdirs ]]; then
545 echo nothing in ~/.iankdirs
546 return 0
547 fi
548
549 i=0
550
551 # note, alternate approach like this, made the following read fail
552 # done < <(tac ~/.iankdirs | awk '!seen[$0]++')
553 # bash: read: read error: 0: Input/output error
554 # which went away by adding a sleep 1 after it.
555
556 mapfile -t lines <~/.iankdirs
557 start=$(( ${#lines[@]} - 1 ))
558
559 # we have ~33 buttons as of this writing, so lets
560 # prune down the history every once in a while.
561 if (( start > 500 )); then
562 tmpfile=$(mktemp)
563 tac ~/.iankdirs | awk '!seen[$0]++' | head -n 200 >$tmpfile
564 cat $tmpfile > ~/.iankdirs
565 fi
566
567 for (( j=$start; j >= 0; j-- )); do
568 line="${lines[$j]}"
569 if [[ ! $line || ${alines[$line]} || ! -d "$line" || $line == "$PWD" || line == "$HOME" ]]; then
570 continue
571 fi
572 alines[$line]=t
573 buttondirs[${buttons[i]}]="$line"
574 printf "%s %s\n" ${buttons[i]} "$line"
575 if (( i == ${#buttons[@]} - 1 )); then
576 break
577 fi
578 i=$(( i + 1 ))
579 done
580
581 if (( i == 0 )); then
582 echo "no dirs in ~/.iankdirs"
583 return 0
584 fi
585 read -r -N 1 input
586 if [[ $input != $'\n' ]]; then
587 c ${buttondirs[$input]}
588 fi
589 }
590 bl() {
591 local start i j max
592 max=10
593 start=$(( ${#_iankdirb[@]} - 1 ))
594
595 # cleanup possible repeating of pwd
596 if (( start >= 0 )) && [[ ${_iankdirb[$start]} == "$PWD" ]]; then
597 start=$(( start - 1 ))
598 fi
599 j=1
600 if (( start >= 0 )); then
601 for (( i=$start; i >= 0 ; i-- )); do
602 printf "%s %s\n" $j ${_iankdirb[i]}
603 j=$(( j + 1 ))
604 if (( j >= max )); then
605 break
606 fi
607 done
608 fi
609
610 max=10
611
612 start=$(( ${#_iankdirf[@]} - 1 ))
613
614 # cleanup possible repeating of pwd
615 if (( start >= 0 )) && [[ ${_iankdirf[$start]} == "$PWD" ]]; then
616 start=$(( start - 1 ))
617 fi
618 if (( start < 0 )); then
619 return 0
620 fi
621 echo --
622 j=1
623 for (( i=$start; i >= 0 ; i-- )); do
624 printf "%s %s\n" $j ${_iankdirf[i]}
625 j=$(( j + 1 ))
626 if (( j >= max )); then
627 break
628 fi
629 done
630 }
631
632
633
634 c4() { c /var/log/exim4; }
635
636 caa() { git commit --amend --no-edit -a; }
637
638 cf() {
639 for f; do
640 hr
641 echo "$f"
642 hr
643 cat "$f"
644 done
645 }
646 caf() {
647 # shellcheck disable=SC2033
648 find -L "$@" -type f -not \( -name .svn -prune -o -name .git -prune \
649 -o -name .hg -prune -o -name .editor-backups -prune \
650 -o -name .undo-tree-history -prune \) \
651 -exec bash -c '. ~/.bashrc; hr; echo "$1"; hr; cat "$1"' _ {} \; 2>/dev/null
652
653 }
654 ccomp cat cf caf
655
656 calc() { echo "scale=3; $*" | bc -l; }
657 # no having to type quotes, but also no command history:
658 clc() {
659 local x
660 read -r x
661 echo "scale=3; $x" | bc -l
662 }
663
664 cam() {
665 git commit -am "$*"
666 }
667
668 ccat () { # config cat. see a config without extra lines.
669 sed -r '/^[[:space:]]*([;#]|--|\/\/|$)/d' "$@"
670 }
671 ccomp grep ccat
672
673 chrbind() {
674 local d
675 # dev/pts needed for pacman signature check
676 for d in dev proc sys dev/pts; do
677 [[ -d $d ]]
678 if ! mountpoint $d &>/dev/null; then
679 m s mount -o bind /$d $d
680 fi
681 done
682 }
683 chumount() {
684 local d
685 # dev/pts needed for pacman signature check
686 for d in dev proc sys dev/pts; do
687 [[ -d $d ]]
688 if mountpoint $d &>/dev/null; then
689 m s umount $d
690 fi
691 done
692 }
693
694
695 _cdiff-prep() {
696 # join options which are continued to multiples lines onto one line
697 local first=true
698 while IFS= read -r line; do
699 # remove leading spaces/tabs. assumes extglob
700 if [[ $line == "[ ]*" ]]; then
701 line="${line##+( )}"
702 fi
703 if $first; then
704 pastline="$line"
705 first=false
706 elif [[ $line == *=* ]]; then
707 echo "$pastline" >> "$2"
708 pastline="$line"
709 else
710 pastline="$pastline $line"
711 fi
712 done < <(grep -vE '^([ \t]*#|^[ \t]*$)' "$1")
713 echo "$pastline" >> "$2"
714 }
715
716 cdiff() {
717 # diff config files,
718 # setup for format of postfix, eg:
719 # option = stuff[,]
720 # [more stuff]
721 local pastline unified f1 f2
722 unified="$(mktemp)"
723 f1="$(mktemp)"
724 f2="$(mktemp)"
725 _cdiff-prep "$1" "$f1"
726 _cdiff-prep "$2" "$f2"
727 cat "$f1" "$f2" | grep -Po '^[^=]+=' | sort | uniq > "$unified"
728 while IFS= read -r line; do
729 # the default bright red / blue doesnt work in emacs shell
730 dwdiff -cblue,red -A best -d " ," <(grep "^$line" "$f1" || echo ) <(grep "^$line" "$f2" || echo ) | colordiff
731 done < "$unified"
732 }
733
734
735 cat-new-files() {
736 local start=$SECONDS
737 local dir="$1"
738 # shellcheck disable=SC2030
739 inotifywait -m "$dir" -e create -e moved_to | \
740 while read -r filedir _ file; do
741 cat "$filedir$file"
742 hr
743 calc $((SECONDS - start)) / 60
744 sleep 5
745 done
746
747 }
748
749 # shellcheck disable=SC2032
750 chown() {
751 # makes it so chown -R symlink affects the symlink and its target.
752 if [[ $1 == -R ]]; then
753 shift
754 command chown -h "$@"
755 command chown -R "$@"
756 else
757 command chown "$@"
758 fi
759 }
760
761 cim() {
762 git commit -m "$*"
763 }
764
765
766 d() { builtin bg "$@"; }
767 ccomp bg d
768
769 dc() {
770 diff --strip-trailing-cr -w "$@" # diff content
771 }
772 ccomp diff dc
773
774 despace() {
775 local x y
776 for x in "$@"; do
777 y="${x// /_}"
778 safe_rename "$x" "$y"
779 done
780 }
781
782 dig() {
783 command dig +nostats +nocmd "$@"
784 }
785 # Output with sections sorted, and removal of query id, so 2 dig outputs can be diffed.
786 digsort() {
787 local sec
788 sec=
789 dig +nordflag "$@" | sed -r 's/^(;; ->>HEADER<<-.*), id: .*/\1/' | while read -r l; do
790 if [[ $l == [^\;]* ]]; then
791 sec+="$l"$'\n'
792 else
793 if [[ $sec ]]; then
794 printf "%s" "$sec" | sort
795 sec=
796 fi
797 printf "%s\n" "$l"
798 fi
799 done
800 }
801 ccomp dig digsort
802 # compare digs to the 2 servers
803 # usage: digdiff @server1 @server2 DIG_ARGS
804 # note: only the soa master nameserver will respond with
805 # ra "recursive answer" flag. That difference is meaningless afaik.
806 digdiff() {
807 local s1 s2
808 s1=$1
809 shift
810 s2=$1
811 shift
812 digsort $s1 "$@" | tee /tmp/digdiff
813 diff -u /tmp/digdiff <(digsort $s2 "$@")
814 }
815
816 dt() {
817 date "+%A, %B %d, %r" "$@"
818 }
819 ccomp date dt
820
821 dus() { # du, sorted, default arg of
822 du -sh ${@:-*} | sort -h
823 }
824 ccomp du dus
825
826
827 e() { echo "$@"; }
828
829 # echo args
830 ea() {
831 if (( ! $# )); then
832 echo no args
833 fi
834 for arg; do
835 printf "%qEOL\n" "${arg}"
836 printf "%s" "${arg}" |& hexdump -C
837 done
838 }
839 # echo vars. print var including escapes, etc
840 ev() {
841 if (( ! $# )); then
842 echo no args
843 fi
844 for arg; do
845 if [[ -v $arg ]]; then
846 printf "%qEOL\n" "${!arg}"
847 printf "%s" "${!arg}" |& hexdump -C
848 else
849 echo arg $arg is unset
850 fi
851 done
852 }
853
854 ediff() {
855 [[ ${#@} == 2 ]] || { echo "error: ediff requires 2 arguments"; return 1; }
856 emacs --eval "(ediff-files \"$1\" \"$2\")"
857 }
858
859 # mail related
860 etail() {
861 tail -F /var/log/exim4/mainlog -n 200 "$@"
862 }
863 ccomp tail etail
864
865 # print exim old pids
866 eoldpids() {
867 local configtime pid piduptime now daemonpid
868 printf -v now '%(%s)T' -1
869 configtime=$(stat -c%Y /var/lib/exim4/config.autogenerated)
870 if [[ -s /run/exim4/exim.pid ]]; then
871 daemonpid=$(cat /run/exim4/exim.pid)
872 fi
873 for pid in $(pgrep -f '^/usr/sbin/exim4( |$)'); do
874 # the daemonpid gets reexeced on HUP (service reloads), keeping its same old timestamp
875 if [[ $pid == $daemonpid ]]; then
876 continue
877 fi
878 piduptime=$(awk -v ticks="$(getconf CLK_TCK)" 'NR==1 { now=$1; next } END { printf "%9.0f\n", now - ($20/ticks) }' /proc/uptime RS=')' /proc/$pid/stat) ||: # sometimes pids disappear pretty fast
879 if (( configtime > now - piduptime )); then
880 echo $pid
881 fi
882 done
883 }
884
885 # exim tail but only watch lines from new pids
886 etailnew() {
887 local pid oldpids
888 for pid in $(eoldpids); do
889 oldpids+="$pid|"
890 done
891 if [[ $oldpids ]]; then
892 etail | awk '$3 !~ /^\[('"${oldpids%|}"')\]$/'
893 else
894 etail
895 fi
896 }
897 # exim watch as old pids go away
898 ewatchold() {
899 local configtime pid piduptime now
900 local -i count
901 local -a oldpids
902 count=0
903 while true; do
904 oldpids=($(eoldpids))
905 if (( ! ${#oldpids[@]} )); then
906 return
907 fi
908 # print the date every 20 iterations
909 if (( ! count % 20 )); then
910 date
911 fi
912 count+=1
913 ps -f -p "${oldpids[*]}"
914 sleep 1
915 done
916 }
917
918 eless() {
919 less /var/log/exim4/mainlog
920 }
921 ccomp less eless
922 eqcat() {
923 exiqgrep -i -o 60 | while read -r i; do
924 hlm exim -Mvc $i
925 echo
926 hlm exigrep $i /var/log/exim4/mainlog | cat ||:
927 done
928 }
929 eqrmf() {
930 exiqgrep -i | xargs exim -Mrm
931 }
932
933 econfdevnew() {
934 rm -rf /tmp/edev
935 mkdir -p /tmp/edev/etc
936 cp -ra /etc/exim4 /tmp/edev/etc
937 cp -ra /etc/alias* /tmp/edev/etc
938 find /tmp/edev/etc/exim4 -type f -execdir sed -i "s,/etc/,/tmp/edev/etc/,g" '{}' +
939 econfdev
940 }
941 econfdev() {
942 update-exim4.conf -d /tmp/edev/etc/exim4 -o /tmp/edev/e.conf
943 }
944
945
946
947
948 fa() {
949 # find array. make an array of file names found by find into $x
950 # argument: find arguments
951 # return: find results in an array $x
952 while read -rd ''; do
953 x+=("$REPLY");
954 done < <(find "$@" -print0);
955 }
956
957 faf() { # find all files. use -L to follow symlinks
958 find "$@" -not \( -name .svn -prune -o -name .git -prune \
959 -o -name .hg -prune -o -name .editor-backups -prune \
960 -o -name .undo-tree-history -prune \) -type f 2>/dev/null
961 }
962
963
964 # mail related
965 frozen() {
966 rm -rf /tmp/frozen
967 sudo mailq |gr frozen|awk '{print $3}' | while read -r id; do
968 sudo exim -Mvl $id
969 echo
970 sudo exim -Mvh $id
971 echo
972 sudo exim -Mvb $id
973 echo -e '\n\n##############################\n'
974 done | tee -a /tmp/frozen
975 }
976 frozenrm() {
977 local ids=()
978 while read -r line; do
979 printf '%s\n' "$line"
980 ids+=($(printf '%s\n' "$line" |gr frozen|awk '{print $3}'))
981 done < <(s mailq)
982 echo "sleeping for 2 in case you change your mind"
983 sleep 2
984 sudo exim -Mrm "${ids[@]}"
985 }
986
987 funce() {
988 # like -e for functions. returns on error.
989 # at the end of the function, disable with:
990 # trap ERR
991 trap 'echo "${BASH_COMMAND:+BASH_COMMAND=\"$BASH_COMMAND\" }
992 ${FUNCNAME:+FUNCNAME=\"$FUNCNAME\" }${LINENO:+LINENO=\"$LINENO\" }\$?=$?"
993 trap ERR
994 return' ERR
995 }
996
997 getdir () {
998 local help="Usage: getdir [--help] PATH
999 Output the directory of PATH, or just PATH if it is a directory."
1000 if [[ $1 == --help ]]; then
1001 echo "$help"
1002 return 0
1003 fi
1004 if [[ $# -ne 1 ]]; then
1005 echo "getdir error: expected 1 argument, got $#"
1006 return 1
1007 fi
1008 if [[ -d $1 ]]; then
1009 echo "$1"
1010 else
1011 local dir
1012 dir="$(dirname "$1")"
1013 if [[ -d $dir ]]; then
1014 echo "$dir"
1015 else
1016 echo "getdir error: directory does not exist"
1017 return 1
1018 fi
1019 fi
1020 }
1021
1022 git_empty_branch() { # start an empty git branch. carefull, it deletes untracked files.
1023 [[ $# == 1 ]] || { echo 'need a branch name!'; return 1;}
1024 local root
1025 root=$(gitroot) || return 1 # function to set gitroot
1026 builtin cd "$root"
1027 git symbolic-ref HEAD refs/heads/$1
1028 rm .git/index
1029 git clean -fdx
1030 }
1031
1032 # shellcheck disable=SC2120
1033 gitroot() {
1034 local help="Usage: gitroot [--help]
1035 Print the full path to the root of the current git repo
1036
1037 Handles being within a .git directory, unlike git rev-parse --show-toplevel,
1038 and works in older versions of git which did not have that."
1039 if [[ $1 == --help ]]; then
1040 echo "$help"
1041 return
1042 fi
1043 local p
1044 p=$(git rev-parse --git-dir) || { echo "error: not in a git repo" ; return 1; }
1045 [[ $p != /* ]] && p=$PWD
1046 echo "${p%%/.git}"
1047 }
1048
1049 g() {
1050
1051 # todo: patch emacs so it will look elsewhere. this is kinda sad:
1052 # https://emacs.stackexchange.com/questions/4253/how-to-start-emacs-with-a-custom-user-emacs-directory
1053
1054 local args gdb=false
1055
1056 if [[ $EMACSDIR ]]; then
1057 path-add "$EMACSDIR/lib-src" "$EMACSDIR/src"
1058 fi
1059
1060 if [[ $DISPLAY ]]; then
1061 args=-n
1062 fi
1063
1064 if (( $# == 0 )); then
1065 args+=" -c"
1066 fi
1067 # duplicate -c, but oh well
1068 if ! pgrep -u $EUID emacsclient; then
1069 if (( $# == 0 )) && type -p gdb &>/dev/null; then
1070 gdb=true
1071 else
1072 args+=" -c"
1073 fi
1074 fi
1075 if [[ $EMACSDIR ]]; then
1076 # Alter the path here, otherwise the nfs mount gets triggered on the
1077 # first path lookup when emacs is not being used.
1078 PATH="$EMACSDIR/lib-src:$EMACSDIR/src:$PATH" EHOME=$HOME HOME=$EMACSDIR m emacsclient -a "" $args "$@"
1079 else
1080 if $gdb; then
1081 # due to a bug, we cant debug from the start unless we get a new gdb
1082 # https://sourceware.org/bugzilla/show_bug.cgi?id=24454
1083 # m gdb -ex="set follow-fork-mode child" -ex=r -ex=quit --args emacs --daemon
1084 m emacsclient -a "" $args "$@"
1085 sleep 1
1086 cd /a/opt/emacs-$(distro-name)$(distro-num)
1087 s gdb -p $(pgrep -f 'emacs --daemon') -ex c
1088 cd -
1089 else
1090 m emacsclient -a "" $args "$@"
1091 fi
1092 fi
1093 }
1094
1095 # force terminal version
1096 gn() {
1097 g -n "$@"
1098 }
1099
1100 gmacs() {
1101 # quit will prompt if the program crashes.
1102 gdb -ex=r -ex=quit --args emacs "$@"; r;
1103 }
1104
1105 gdkill() {
1106 # kill the emacs daemon
1107 pk1 emacs --daemon
1108 }
1109
1110 gr() {
1111 grep -iIP --color=auto "$@" || return $?
1112 }
1113 grr() { # grep recursive
1114 # Don't return 1 on nonmatch because this is meant to be
1115 # interactive, not in a conditional.
1116 if [[ ${#@} == 1 ]]; then
1117 grep --exclude-dir='*.emacs.d' --exclude-dir='*.git' -riIP --color=auto "$@" . || [[ $? == 1 ]]
1118 else
1119 grep --exclude-dir='*.emacs.d' --exclude-dir='*.git' -riIP --color=auto "$@" || [[ $? == 1 ]]
1120 fi
1121 }
1122 ccomp grep gr grr
1123
1124 rg() { grr "$@"; }
1125 ccomp grep rg
1126
1127 hr() { # horizontal row. used to break up output
1128 printf "$(tput setaf 5 2>/dev/null ||:)â–ˆ$(tput sgr0 2>/dev/null||:)%.0s" $(eval echo "{1..${COLUMNS:-60}}")
1129 echo
1130 }
1131 # highlight
1132 hl() {
1133 local col input_len=0
1134 for arg; do
1135 input_len=$((input_len + 1 + ${#arg}))
1136 done
1137 col=$((60 - input_len))
1138 printf "\e[1;97;41m%s" "$*"
1139 if (( col > 0 )); then
1140 printf "\e[1;97;41m \e[0m%.0s" $(eval echo "{1..${col}}")
1141 fi
1142 echo
1143 }
1144 hlm() { hl "$*"; "$@"; }
1145
1146 hrcat() { local f; for f; do [[ -f $f ]] || continue; hr; echo "$f"; cat "$f"; done }
1147
1148
1149 # get latest hub and run it
1150 # main command to use:
1151 # hub pull-request --no-edit
1152 # --no-edit means to use the first commit\'s message as the pull request message.
1153 # If that fails, try doing
1154 # hub pull-request --no-edit -b UPSTREAM_OWNER:branch
1155 # where branch is usually master. it does the pr against your current branch.
1156 #
1157 # On first use, you input username/pass and it gets an oath token so you dont have to repeat
1158 # it\'s at ~/.config/hub
1159 hub() {
1160 local up uptar updir p
1161 p=/github/hub/releases/
1162 up=https://github.com/$(curl -s https://github.com$p| grep -o $p'download/[^/]*/hub-linux-amd64[^"]*' | head -n1)
1163 uptar=${up##*/}
1164 updir=${uptar%.tgz}
1165 if [[ ! -e /a/opt/$updir ]]; then
1166 rm -rf /a/opt/hub-linux-amd64*
1167 wget -P /a/opt $up
1168 tar -C /a/opt -zxf /a/opt/$uptar
1169 rm -f /a/opt/$uptar
1170 fi
1171 if ! which hub &>/dev/null; then
1172 sudo /a/opt/$updir/install
1173 fi
1174
1175 # save token across computers
1176 if [[ ! -L ~/.config/hub ]]; then
1177 if [[ -e ~/.config/hub ]]; then
1178 mv ~/.config/hub /p/c/subdir_files/.config/
1179 fi
1180 if [[ -e /p/c/subdir_files/.config/hub ]]; then
1181 conflink
1182 fi
1183 fi
1184 command hub "$@"
1185 }
1186
1187 i() { git "$@"; }
1188 ccomp git i
1189
1190 ic() {
1191 # fast commit all
1192 git commit -am "$*"
1193 }
1194
1195 ipp() {
1196 git pull
1197 git push
1198 }
1199
1200
1201 ifn() {
1202 # insensitive find
1203 find -L . -not \( -name .svn -prune -o -name .git -prune \
1204 -o -name .hg -prune -o -name .editor-backups -prune \
1205 -o -name .undo-tree-history -prune \) -iname "*$**" 2>/dev/null
1206 }
1207
1208 ifd() {
1209 # insensitive find directory
1210 find -L . -type d -not \( -name .svn -prune -o -name .git -prune \
1211 -o -name .hg -prune -o -name .editor-backups -prune \
1212 -o -name .undo-tree-history -prune \) -iname "*$**" 2>/dev/null
1213 }
1214
1215
1216 ipdrop() {
1217 sudo iptables -A INPUT -s $1 -j DROP
1218 }
1219
1220
1221 istext() {
1222 grep -Il "" "$@" &>/dev/null
1223 }
1224
1225 jtail() {
1226 journalctl -n 10000 -f "$@"
1227 }
1228 jr() { journalctl "$@" ; }
1229 jrf() { journalctl -f "$@" ; }
1230 jru() {
1231 journalctl -u exim4 _SYSTEMD_INVOCATION_ID=$(systemctl show -p InvocationID --value $1)
1232 }
1233
1234 l() {
1235 if [[ $PWD == /[iap] ]]; then
1236 command ls -A --color=auto -I lost+found "$@"
1237 else
1238 command ls -A --color=auto "$@"
1239 fi
1240 }
1241
1242 lcn() { locate -i "*$**"; }
1243
1244 lg() { LC_COLLATE=C.UTF-8 ll --group-directories-first "$@"; }
1245
1246 lt() { ll -tr "$@"; }
1247
1248 lld() { ll -d "$@"; }
1249
1250 ccomp ls l lg lt lld ll
1251
1252 # low recursively
1253 lowr() {
1254 local f dirs i a
1255 local -a all
1256 for dirs in false true; do
1257 for f; do
1258 if [[ -d $f ]]; then
1259 all=("$f"/**)
1260 # reverse the order to rename the nested dirs first.
1261 # note: 0 element is the dir itself
1262 for ((i=${#all[@]}-1; i>=1; i--)); do
1263 a="${all[i]}"
1264 if $dirs && [[ -d $a ]]; then
1265 # e dirs low "$a" # debug
1266 low "$a"
1267 elif ! $dirs && [[ ! -d $a && -e $a ]]; then
1268 # debug
1269 # e not dirs low "$a" # debug
1270 low "$a"
1271 fi
1272 done
1273 fi
1274 # just rename all the top level args on the second pass
1275 if $dirs; then
1276 # e final dirs low "$f" # debug
1277 low "$f"
1278 fi
1279 done
1280 done
1281 }
1282
1283 low() { # make filenames lowercase, remove bad chars
1284 local arg new dir f
1285 for arg; do
1286 arg="${arg%%+(/)}" # remove trailing slashes. assumes we have extglob on.
1287 dir="${arg%/*}"
1288 if (( ${#dir} == ${#arg} )); then
1289 dir=.
1290 fi
1291 f="${arg##*/}"
1292 new="${f,,}" # downcase
1293 new="${new//[^a-zA-Z0-9._-]/_}" # sub bad chars
1294 new="${new#"${new%%[[:alnum:]]*}"}" # remove leading/trailing non-alnum
1295 new="${new%"${new##*[[:alnum:]]}"}"
1296 # remove bad underscores, like __ and _._
1297 new=$(echo $new | sed -r 's/__+/_/g;s/_+([.-])|([.-])_+/\1/g')
1298 safe_rename "$dir/$f" "$dir/$new" || return 1
1299 done
1300 return 0
1301 }
1302
1303 lower() { # make first letter of filenames lowercase.
1304 local x
1305 for x in "$@"; do
1306 if [[ ${x::1} == [A-Z] ]]; then
1307 y=$(tr '[:upper:]' '[:lower:]' <<<"${x::1}")"${x:1}"
1308 safe_rename "$x" "$y" || return 1
1309 fi
1310 done
1311 }
1312
1313
1314 k() { # history search
1315 grep -iP --binary-files=text "$@" ${HISTFILE:-~/.bash_history} | tail -n 80 || [[ $? == 1 ]];
1316 }
1317 ks() { # history search with context
1318 # args are an extended regex used by sed
1319 history | sed -nr "h;s/^\s*(\S+\s+){4}//;/$*/{g;p}" | tail -n 80 || [[ $? == 1 ]];
1320 }
1321 ksu() { # history search unique
1322 grep -P --binary-files=text "$@" ${HISTFILE:-~/.bash_history} | uniq || [[ $? == 1 ]];
1323 }
1324
1325 # todo: id like to do maybe a daily or hourly cronjob to
1326 # check that my history file size is increasing. Ive had it
1327 # inexplicably truncated in the past.
1328 histrm() {
1329 history -n
1330 HISTTIMEFORMAT= history | awk -v IGNORECASE=1 '{ a=$1; sub(/^ *[^ ]+ */, "") }; /'"$*"'/'
1331 read -p "press anything but contrl-c to delete"
1332 for entry in $(HISTTIMEFORMAT= history | awk -v IGNORECASE=1 '{ a=$1; sub(/^ *[^ ]+ */, "") }; /'"$*"'/ { print a }' | tac); do
1333 history -d $entry
1334 done
1335 history -w
1336 }
1337
1338 ccomp grep k ks ksu histrm
1339
1340
1341 make-targets() {
1342 # show make targets, via http://stackoverflow.com/questions/3063507/list-goals-targets-in-gnu-make
1343 make -qp | awk -F':' '/^[a-zA-Z0-9][^$#\/\t=]*:([^=]|$)/ {split($1,A,/ /);for(i in A)print A[i]}'
1344 }
1345
1346 mkc() {
1347 mkdir "$1"
1348 c "$1"
1349 }
1350 ccomp mkdir mkc
1351
1352 mkct() {
1353 mkc $(mktemp -d)
1354 }
1355
1356 mkt() { # mkdir and touch file
1357 local path="$1"
1358 mkdir -p "$(dirname "$path")"
1359 touch "$path"
1360 }
1361
1362 # shellcheck disable=SC2032
1363 mkdir() { command mkdir -p "$@"; }
1364
1365 nags() {
1366 # https://github.com/HenriWahl/Nagstamon/issues/357
1367 if ! pgrep -f /usr/lib/notification-daemon/notification-daemon >/dev/null; then
1368 /usr/lib/notification-daemon/notification-daemon &
1369 fi
1370 /usr/bin/nagstamon &
1371 }
1372
1373 nmt() {
1374 s nmtui-connect "$@"
1375 }
1376
1377 nopanic() {
1378 # shellcheck disable=SC2024
1379 sudo tee -a /var/log/exim4/paniclog-archive </var/log/exim4/paniclog; sudo truncate -s0 /var/log/exim4/paniclog
1380 }
1381
1382 p8() { ping "$@" 8.8.8.8; }
1383 p6() { ping6 "$@" 2001:4860:4860::8888; }
1384
1385 pkx() { # package extract
1386 local pkg cached tmp f
1387 c $(mktemp -d)
1388 pkg=$1
1389 # shellcheck disable=SC2012
1390 cached=$(ls -t /var/cache/apt/archives/$pkg* | tail -n1 2>/dev/null) ||:
1391 if [[ $cached ]]; then
1392 cp $cached .
1393 else
1394 aptitude download $pkg || return 1
1395 fi
1396 tmp=(*); f=${tmp[0]} # only 1 expected
1397 ex $f
1398 rm -f $f
1399 }
1400
1401 # pgrep and kill
1402 pk1() {
1403 local pid
1404 pid=($(pgrep -f "$*"))
1405 case ${#pid[@]} in
1406 1)
1407 # shellcheck disable=SC2128
1408 {
1409 ps -F $pid
1410 m kill $pid
1411 }
1412 ;;
1413 0) echo "no pid found" ;;
1414 *)
1415 ps -F ${pid[@]}
1416 ;;
1417 esac
1418 }
1419
1420 psg () {
1421 local x y help
1422 help="Usage: psg [--help] GREP_ARGS
1423 grep ps and output in a nice format"
1424 if [[ $1 == --help ]]; then
1425 echo "$help"
1426 return
1427 fi
1428 x=$(ps -eF)
1429 # final grep is because some commands tend to have a lot of trailing spaces
1430 y=$(echo "$x" | grep -iP "$@" | grep -o '.*[^ ]') ||:
1431 if [[ $y ]]; then
1432 echo "$x" | head -n 1 || [[ $? == 141 ]]
1433 echo "$y"
1434 fi
1435 }
1436
1437 pubip() { curl -4s https://icanhazip.com; }
1438 pubip6() { curl -6s https://icanhazip.com; }
1439 whatismyip() { pubip; }
1440
1441
1442 q() { # start / launch a program in the backround and redir output to null
1443 "$@" &> /dev/null &
1444 }
1445
1446 # shellcheck disable=SC2120
1447 r() {
1448 if [[ $HISTFILE ]]; then
1449 history -a # save history
1450 fi
1451 trap ERR # this avoids a segfault
1452 exit ${1:0}
1453 # i had this redir, not sure why
1454 # exit "$@" 2>/dev/null
1455 }
1456
1457 # scp is insecure and deprecated.
1458 scp() {
1459 rsync --inplace "$@"
1460 }
1461
1462 randport() {
1463 # available high ports are 1024-65535,
1464 # but lets skip things that are more likely to be in use
1465 python3 <<'EOF'
1466 import secrets
1467 print(secrets.SystemRandom().randrange(10002,65500))
1468 EOF
1469 }
1470
1471 # reapply bashrc
1472 reb() {
1473 source ~/.bashrc
1474 }
1475
1476 rl() {
1477 readlink -f "$@"
1478 }
1479 ccomp readlink rl
1480
1481 rsd() {
1482 # rsync, root is required to keep permissions right.
1483 # rsync --archive --human-readable --verbose --itemize-changes --checksum \(-ahvic\) \
1484 # --no-times --delete
1485 # basically, make an exact copy, use checksums instead of file times to be more accurate
1486 rsync -ahvic --delete "$@"
1487 }
1488 rsa() {
1489 # like rlu, but dont delete files on the target end which
1490 # do not exist on the original end.
1491 rsync -ahvic "$@"
1492 }
1493 rst() {
1494 # rl without preserving modification time.
1495 rsync -ahvic --delete --no-t "$@"
1496 }
1497 rsu() { # [OPTS] HOST PATH
1498 # eg. rlu -opts frodo /testpath
1499 # relative paths will expanded with readlink -f.
1500 opts=("${@:1:$#-2}") # 1 to last -2
1501 path="${*:$#}" # last
1502 host="${*:$#-1:1}" # last -1
1503 if [[ $path == .* ]]; then
1504 path=$(readlink -f $path)
1505 fi
1506 # rync here uses checksum instead of time so we dont mess with
1507 # unison relying on time as much. g is for group, same reason
1508 # to keep up with unison.
1509 m s rsync -rlpchviog --relative "${opts[@]}" "$path" "root@$host:/";
1510 }
1511 ccomp rsync rsd rsa rst rsu
1512
1513 # find programs listening on a port
1514 ssp() {
1515 local port=$1
1516 # to figure out these args, i had to look at the man page from git version, as of 2022-04.
1517 s ss -lpn state listening sport = $port
1518 }
1519
1520 resolvcat() {
1521 local f
1522 if [[ $(systemctl is-active nscd ||:) != inactive ]]; then
1523 m s nscd -i hosts
1524 fi
1525 f=/etc/resolv.conf
1526 echo $f:; ccat $f
1527 hr; s ss -lpn sport = 53
1528 if systemctl is-enabled dnsmasq &>/dev/null || [[ $(systemctl is-active dnsmasq ||:) != inactive ]]; then
1529 # this will fail is dnsmasq is failed
1530 hr; m ser status dnsmasq | cat || :
1531 f=/etc/dnsmasq.conf
1532 hr; echo $f:; ccat $f
1533 hr; m grr '^ *(servers-file|server) *=|^ *no-resolv *$' /etc/dnsmasq.conf /etc/dnsmasq.d
1534 f=/etc/dnsmasq-servers.conf
1535 hr; echo $f:; ccat $f
1536 fi
1537 hr
1538 echo /etc/nsswitch.conf:
1539 grep '^ *hosts:' /etc/nsswitch.conf
1540 if systemctl is-enabled systemd-resolved &>/dev/null || [[ $(systemctl is-active systemd-resolved ||:) != inactive ]]; then
1541 hr; m ser status systemd-resolved | cat || :
1542 hr; m systemd-resolve --status | cat
1543 fi
1544
1545 }
1546 rcat() {
1547 resolvcat | less
1548 }
1549 reresolv() {
1550 if [[ $(systemctl is-active nscd ||:) != inactive ]]; then
1551 m ser stop nscd
1552 sleep .5
1553 m ser start nscd
1554 m sudo nscd -i hosts
1555 fi
1556 if [[ $(systemctl is-active dnsmasq ||:) != inactive ]]; then
1557 m sudo systemctl restart dnsmasq
1558 fi
1559 if [[ $(systemctl is-active systemd-resolved ||:) != inactive ]]; then
1560 m sudo systemctl restart systemd-resolved
1561 fi
1562 if type -P resolvectl &>/dev/null; then
1563 resolvectl flush-caches
1564 fi
1565 }
1566
1567 rmstrips() {
1568 ssh fencepost head -n 300 /gd/gnuorg/EventAndTravelInfo/rms-current-trips.txt | less
1569 }
1570
1571 sudo () {
1572 command sudo "$@" || return $?
1573 DID_SUDO=true
1574 }
1575 s() {
1576 # background
1577 # I use a function because otherwise we cant use in a script,
1578 # cant assign to variable.
1579 #
1580 # note: gksudo is recommended for X apps because it does not set the
1581 # home directory to the same, and thus apps writing to ~ fuck things up
1582 # with root owned files.
1583 #
1584 if [[ $EUID != 0 || $1 == -* ]]; then
1585 # shellcheck disable=SC2034
1586 SUDOD="$PWD" command sudo -i "$@"
1587 DID_SUDO=true
1588 else
1589 "$@"
1590 fi
1591 }
1592 sb() { # sudo bash -c
1593 # use sb instead of s is for sudo redirections,
1594 # eg. sb 'echo "ok fine" > /etc/file'
1595 # shellcheck disable=SC2034
1596 local SUDOD="$PWD"
1597 sudo -i bash -c "$@"
1598 }
1599 ccomp sudo s sb
1600
1601 safe_rename() { # warn and dont rename if file exists.
1602 # mv -n exists, but it\'s silent
1603 if [[ $# != 2 ]]; then
1604 echo safe_rename error: $# args, need 2 >2
1605 return 1
1606 fi
1607 if [[ $1 != "$2" ]]; then # yes, we want to silently ignore this
1608 if [[ -e $2 || -L $2 ]]; then
1609 echo "Cannot rename $1 to $2 as it already exists."
1610 else
1611 mv -vi "$1" "$2"
1612 fi
1613 fi
1614 }
1615
1616
1617 sd() {
1618 sudo dd status=none of="$1"
1619 }
1620
1621 ser() {
1622 if type -p systemctl &>/dev/null; then
1623 s systemctl "$@"
1624 else
1625 if (( $# >= 3 )); then
1626 echo iank: ser expected 2 or less arguments
1627 return 1
1628 fi
1629 s service $2 $1
1630 fi
1631 }
1632 serstat() {
1633 systemctl -n 40 status "$@"
1634 }
1635
1636 seru() { systemctl --user "$@"; }
1637 # like restart, but do nothing if its not already started
1638 srestart() {
1639 local service=$1
1640 if [[ $(s systemctl --no-pager show -p ActiveState $service ) == ActiveState=active ]]; then
1641 systemctl restart $service
1642 fi
1643 }
1644
1645 setini() { # set a value in a .ini style file
1646 key="$1" value="$2" section="$3" file="$4"
1647 if [[ -s $file ]]; then
1648 sed -ri -f - "$file" <<EOF
1649 # remove existing keys
1650 / *\[$section\]/,/^ *\[[^]]+\]/{/^\s*$key[[:space:]=]/d}
1651 # add key
1652 /^\s*\[$section\]/a $key=$value
1653 # from section to eof, do nothing
1654 /^\s*\[$section\]/,\$b
1655 # on the last line, if we haven't found section yet, add section and key
1656 \$a [$section]\\
1657 $key=$value
1658 EOF
1659 else
1660 cat >"$file" <<EOF
1661 [$section]
1662 $key=$value
1663 EOF
1664 fi
1665 }
1666
1667 sgo() { # service go
1668 service=$1
1669 ser restart $service || return 1
1670 if type -p systemctl &>/dev/null; then
1671 ser enable $service
1672 fi
1673 }
1674 soff () {
1675 for service; do
1676 # ignore services that dont exist
1677 if systemctl cat $service &>/dev/null; then
1678 ser stop $service;
1679 ser disable $service
1680 fi
1681 done
1682 }
1683
1684 sgu() {
1685 systemctl list-unit-files | rg "$@"
1686 }
1687
1688
1689 sk() {
1690
1691
1692 # disable a warning with:
1693 # shellcheck disable=SC2206 # reasoning
1694
1695 # see bash-template/style-guide.md for justifications
1696
1697 local quotes others
1698 quotes=2048,2068,2086,2206
1699 others=2029,2033,2164
1700 shellcheck -W 999 -x -e $quotes,$others "$@" || return $?
1701 }
1702
1703
1704 # sl: ssh, but firsh rsync our bashrc and related files to a special
1705 # directory on the remote host if needed.
1706
1707 # Some environment variables and files need to be setup for this to work
1708 # (mine are set at the beginning of this file)
1709
1710 # SL_FILES_DIR: Environment variable. Path to folder which should at
1711 # least have a .bashrc file or symlink. This dir will be rsynced to ~ on
1712 # remote hosts (top level symlinks are resolved) unless the host already
1713 # has a $SL_FILES_DIR/.bashrc. In that case, we assume it is a host you
1714 # control and sync files to separately and already has the ~/.bashrc you
1715 # want. The remote bash will also take its .inputrc config from this
1716 # folder (default of not existing is fine). Mine looks like this:
1717 # https://iankelling.org/git/?p=distro-setup;a=tree;f=sl/.iank
1718
1719 # SL_INFO_DIR: Environment variable. This folder stores info about what
1720 # we detected on the remote system and when we last synced. It will be created
1721 # if it does not exist. Sometimes you may want to forget about a
1722 # remote system, you can use sl --rsync, or the function for that slr
1723 # below.
1724
1725 # SL_TEST_CMD: Env var. Meant to be used to vary the files synced
1726 # depending on the remote host. Run this string on the remote host the
1727 # first time sl is run (or if we run slr). The result is passed to
1728 # SL_TEST_HOOK. For example,
1729 # export SL_TEST_CMD=". /etc/os-release ; echo \${VERSION//[^a-zA-Z0-9]/}"
1730
1731 # SL_TEST_HOOK: Env var. It is run as $SL_TEST_HOOK. This can set
1732 # $SL_FILES_DIR to vary the files synced.
1733
1734 # SL_RSYNC_ARGS: Env var. String of arguments passed to rsync. For
1735 # example to exclude files within a directory. Note, excluded
1736 # files wont be deleted on rsync, you can add --delete-excluded
1737 # to the rsync command if that is desired.
1738
1739 # SL_SSH_ARGS: Env var. Default arguments passed to ssh.
1740
1741 # For when ~/.bashrc is already customized on the remote server, you
1742 # might find it problematic that ~/.bashrc is sourced for ALL ssh
1743 # commands, even in scripts. This paragraph is all about that. bash
1744 # scripts dont source ~/.bashrc, but call ssh in scripts and you get
1745 # ~/.bashrc. You dont want this. .bashrc is meant for interactive shells
1746 # and if you customize it, probably has bugs from time to time. This is
1747 # bad. Here's how I fix it. I have a special condition to "return" in my
1748 # .bashrc for noninteractive ssh shells (copy that code). Then use this
1749 # function or similar that passes LC_USEBASHRC=t when sshing and I want
1750 # my bashrc. Also, I don't keep most of my bashrc in .bashrc, i source a
1751 # separate file because even if I return early on, the whole file gets
1752 # parsed which can fail if there is a syntax error.
1753 sl() {
1754 # Background on LC_USEBASHRC var (no need to read if you just want to
1755 # use this function): env variables sent across ssh are strictly
1756 # limited, but we get LC_* at least in debian based machines, so we
1757 # just make that * be something no normal program would use. Note, on
1758 # hosts that dont allow LC_* I start an inner shell with LC_USEBASHRC
1759 # set, and the inner shell also allows running a nondefault
1760 # .bashrc. This means the outer shell still ran the default .bashrc,
1761 # but that is the best we can do.
1762
1763 local now args remote dorsync haveinfo tmpa sshinfo tmp tmp2 type info_sec force_rsync \
1764 sync_dirname testcmd extra_info testbool files_sec sl_test_cmd sl_test_hook
1765 declare -a args tmpa
1766
1767 args=($SL_SSH_ARGS)
1768
1769 # ssh [-1246Antivivisectionist] [-b bind_address] [-c cipher_spec] [-D [bind_address:]port]
1770 # [-E log_file] [-e escape_char] [-F configfile] [-I pkcs11] [-i identity_file] [-L address]
1771 # [-l login_name] [-m mac_spec] [-O ctl_cmd] [-o option] [-p port] [-Q query_option]
1772 # [-R address] [-S ctl_path] [-W host:port] [-w local_tun[:remote_tun]] [user@]hostname
1773 # [command]
1774
1775 # ssh [-46AaCfGgKkMNnqsTtVvXxYy] [-b bind_address] [-c cipher_spec]
1776 # [-D [bind_address:]port] [-E log_file] [-e escape_char]
1777 # [-F configfile] [-I pkcs11] [-i identity_file]
1778 # [-J [user@]host[:port]] [-L address] [-l login_name] [-m mac_spec]
1779 # [-O ctl_cmd] [-o option] [-p port] [-Q query_option] [-R address]
1780 # [-S ctl_path] [-W host:port] [-w local_tun[:remote_tun]]
1781
1782 force_rsync=false
1783 if [[ $1 == --rsync ]]; then
1784 force_rsync=true
1785 shift
1786 fi
1787
1788 sl_test_cmd=$SL_TEST_CMD
1789 sl_test_hook=$SL_TEST_HOOK
1790 sl_rsync_args=$SL_RSYNC_ARGS
1791 while [[ $1 ]]; do
1792 case "$1" in
1793 --rsync)
1794 force_rsync=true
1795 ;;
1796 --sl-test-cmd)
1797 sl_test_cmd="$2"
1798 shift
1799 ;;
1800 --sl-test-hook)
1801 sl_test_hook="$2"
1802 shift
1803 ;;
1804 --sl-rsync-args)
1805 sl_rsync_args="$2"
1806 shift
1807 ;;
1808 *)
1809 break
1810 ;;
1811 esac
1812 shift
1813 done
1814
1815 while [[ $1 ]]; do
1816 case "$1" in
1817 # note we dont support things like -4oOption
1818 -[46AaCfGgKkMNnqsTtVvXxYy]*)
1819 args+=("$1"); shift
1820 ;;
1821 -[bcDEeFIiJLlmOopQRSWw]*)
1822 # -oOption etc is valid
1823 if (( ${#1} >= 3 )); then
1824 args+=("$1"); shift
1825 else
1826 args+=("$1" "$2"); shift 2
1827 fi
1828 ;;
1829 *)
1830 break
1831 ;;
1832 esac
1833 done
1834 remote="$1"
1835 if [[ ! $remote ]]; then
1836 echo $0: error hostname required >&2
1837 return 1
1838 fi
1839 shift
1840
1841 if [[ ! $SL_INFO_DIR ]]; then
1842 echo error: missing '$SL_INFO_DIR' env var >&2
1843 return 1
1844 fi
1845
1846 dorsync=false
1847 haveinfo=false
1848 tmpa=($SL_INFO_DIR/???????????"$remote")
1849 sshinfo=${tmpa[0]}
1850 if [[ -e $sshinfo ]]; then
1851 if $force_rsync; then
1852 rm -f $sshinfo
1853 else
1854 haveinfo=true
1855 fi
1856 fi
1857 if $haveinfo; then
1858 tmp=${sshinfo[0]##*/}
1859 tmp2=${tmp::11}
1860 type=${tmp2: -1}
1861 extra_info=$(cat $sshinfo)
1862 else
1863 # we test for string to know ssh succeeded
1864 testbool="test -e $SL_FILES_DIR/.bashrc -a -L .bashrc -a -v LC_USEBASHRC"
1865 testcmd="if $testbool; then printf y; else printf n; fi"
1866 if ! tmp=$(LC_USEBASHRC=y command ssh "${args[@]}" "$remote" "$testcmd; $sl_test_cmd"); then
1867 echo failed sl test. doing plain ssh -v
1868 command ssh -v "${args[@]}" "$remote"
1869 fi
1870 if [[ $tmp == y* ]]; then
1871 type=a
1872 else
1873 dorsync=true
1874 type=b
1875 fi
1876 extra_info="${tmp:1}"
1877 fi
1878 if [[ $sl_test_hook ]]; then
1879 RSYNC_RSH="ssh ${args[*]}" $sl_test_hook "$extra_info" "$remote"
1880 fi
1881
1882 if $haveinfo && [[ $type == b ]]; then
1883 info_sec=${tmp::10}
1884 read files_sec _ < <(find -L $SL_FILES_DIR -printf "%T@ %p\n" | sort -nr || [[ $? == 141 || ${PIPESTATUS[0]} == 32 ]] )
1885 files_sec=${files_sec%%.*}
1886 if (( files_sec > info_sec )); then
1887 dorsync=true
1888 rm -f $sshinfo
1889 fi
1890 fi
1891
1892 sync_dirname=${SL_FILES_DIR##*/}
1893
1894 if [[ ! $SL_FILES_DIR ]]; then
1895 echo error: missing '$SL_FILES_DIR' env var >&2
1896 return 1
1897 fi
1898
1899 if $dorsync; then
1900 RSYNC_RSH="ssh ${args[*]}" m rsync -rptL --delete $sl_rsync_args $SL_FILES_DIR "$remote":
1901 fi
1902 if $dorsync || ! $haveinfo; then
1903 sshinfo=$SL_INFO_DIR/$EPOCHSECONDS$type"$remote"
1904 [[ -e $SL_INFO_DIR ]] || mkdir -p $SL_INFO_DIR
1905 printf "%s\n" "$extra_info" >$sshinfo
1906 chmod 666 $sshinfo
1907 fi
1908 if [[ $type == b ]]; then
1909 if (( ${#@} )); then
1910 # Theres a couple ways to pass arguments, im not sure whats best,
1911 # but relying on bash 4.4+ escape quoting seems most reliable.
1912 command ssh "${args[@]}" "$remote" \
1913 LC_USEBASHRC=t bash -c '.\ '$sync_dirname'/.bashrc\;"\"\$@\""' bash ${@@Q}
1914 elif [[ ! -t 0 ]]; then
1915 # This case is when commands are being piped to ssh.
1916 # Normally, no bashrc gets sourced.
1917 # But, since we are doing all this, lets source it because we can.
1918 cat <(echo . $sync_dirname/.bashrc) - | command ssh "${args[@]}" "$remote" LC_USEBASHRC=t bash
1919 else
1920 command ssh -t "${args[@]}" "$remote" LC_USEBASHRC=t INPUTRC=$sync_dirname/.inputrc bash --rcfile $sync_dirname/.bashrc
1921 fi
1922 else
1923 if [[ -t 0 ]]; then
1924 LC_USEBASHRC=t command ssh "${args[@]}" "$remote" ${@@Q}
1925 else
1926 command ssh "${args[@]}" "$remote" LC_USEBASHRC=t bash
1927 fi
1928 fi
1929 # this function inspired from https://github.com/Russell91/sshrc
1930 }
1931
1932 slr() {
1933 sl --rsync "$@"
1934 }
1935 sss() { # ssh solo
1936 sl -oControlMaster=no -oControlPath=/ "$@"
1937 }
1938 # kill off old shared socket then ssh
1939 ssk() {
1940 m ssh -O exit "$@" || [[ $? == 255 ]]
1941 m sl "$@"
1942 }
1943 ccomp ssh sl slr sss ssk
1944 # plain ssh
1945 ssh() {
1946 if [[ $TERM == alacritty || $TERM == xterm-kitty ]]; then
1947 TERM=xterm-256color LC_USEBASHRC=t command ssh "$@"
1948 else
1949 LC_USEBASHRC=t command ssh "$@"
1950 fi
1951 }
1952
1953
1954 slog() {
1955 # log with script. timing is $1.t and script is $1.s
1956 # -l to save to ~/typescripts/
1957 # -t to add a timestamp to the filenames
1958 local logdir do_stamp arg_base
1959 (( $# >= 1 )) || { echo "arguments wrong"; return 1; }
1960 logdir="/a/dt/"
1961 do_stamp=false
1962 while getopts "lt" option
1963 do
1964 case $option in
1965 l ) arg_base=$logdir ;;
1966 t ) do_stamp=true ;;
1967 esac
1968 done
1969 shift $((OPTIND - 1))
1970 arg_base+=$1
1971 [[ -e $logdir ]] || mkdir -p $logdir
1972 $do_stamp && arg_base+=$(date +%F.%T%z)
1973 script -t $arg_base.s 2> $arg_base.t
1974 }
1975 splay() { # script replay
1976 #logRoot="$HOME/typescripts/"
1977 #scriptreplay "$logRoot$1.t" "$logRoot$1.s"
1978 scriptreplay "$1.t" "$1.s"
1979 }
1980
1981 sr() {
1982 # sudo redo. be aware, this command may not work right on strange distros or earlier software
1983 if [[ $# == 0 ]]; then
1984 sudo -E bash -c -l "$(history -p '!!')"
1985 else
1986 echo this command redos last history item. no argument is accepted
1987 fi
1988 }
1989
1990 srm () {
1991 # with -ll, less secure but faster.
1992 command srm -ll "$@"
1993 }
1994
1995 srun() {
1996 scp $2 $1:/tmp
1997 ssh $1 /tmp/${2##*/} $(printf "%q\n" "${@:2}")
1998 }
1999
2000
2001 swap() {
2002 local tmp
2003 tmp=$(mktemp)
2004 mv $1 $tmp
2005 mv $2 $1
2006 mv $tmp $2
2007 }
2008
2009 tclock() { # terminal clock
2010 local x
2011 clear
2012 date +%l:%_M
2013 len=60
2014 # this goes to full width
2015 #len=${1:-$((COLUMNS -7))}
2016 x=1
2017 while true; do
2018 if (( x == len )); then
2019 end=true
2020 d="$(date +%l:%_M) "
2021 else
2022 end=false
2023 d=$(date +%l:%M:%_S)
2024 fi
2025 echo -en "\r"
2026 echo -n "$d"
2027 for ((i=0; i<x; i++)); do
2028 if (( i % 6 )); then
2029 echo -n _
2030 else
2031 echo -n .
2032 fi
2033 done
2034 if $end; then
2035 echo
2036 x=1
2037 else
2038 x=$((x+1))
2039 fi
2040 sleep 5
2041 done
2042 }
2043
2044
2045 te() {
2046 # test existence / exists
2047 local ret=0
2048 for x in "$@"; do
2049 [[ -e "$x" || -L "$x" ]] || ret=1
2050 done
2051 return $ret
2052 }
2053
2054 psoff() {
2055 # normally, i would just execute these commands in the function.
2056 # however, DEBUG is not inherited, so we need to run it outside a function.
2057 # And we want to run set -x afterwards to avoid spam, so we cram everything
2058 # in here, and then it will run after this function is done.
2059 PROMPT_COMMAND='trap DEBUG; unset PROMPT_COMMAND; PS1="\w \$ "'
2060 }
2061 pson() {
2062 PROMPT_COMMAND=prompt-command
2063 if [[ $TERM == *(screen*|xterm*|rxvt*) ]]; then
2064 trap 'settitle "$BASH_COMMAND"' DEBUG
2065 fi
2066 }
2067
2068 tx() { # toggle set -x, and the prompt so it doesnt spam
2069 if [[ $- == *x* ]]; then
2070 set +x
2071 pson
2072 else
2073 psoff
2074 fi
2075 }
2076
2077 psnetns() {
2078 # show all processes in the network namespace $1.
2079 # blank entries appear to be subprocesses/threads
2080 local x netns
2081 netns=$1
2082 ps -w | head -n 1
2083 sudo find -L /proc/[1-9]*/task/*/ns/net -samefile /run/netns/$netns | cut -d/ -f5 | \
2084 while read -r l; do
2085 x=$(ps -w --no-headers -p $l);
2086 if [[ $x ]]; then echo "$x"; else echo $l; fi;
2087 done
2088 }
2089 nonet() {
2090 if ! s ip netns list | grep -Fx nonet &>/dev/null; then
2091 s ip netns add nonet
2092 fi
2093 sudo -E env /sbin/ip netns exec nonet sudo -E -u iank /bin/bash
2094 }
2095
2096 m() { printf "%s\n" "$*"; "$@"; }
2097
2098 uptime() {
2099 if type -p uprecords &>/dev/null; then
2100 uprecords -B
2101 else
2102 command uptime
2103 fi
2104 }
2105
2106 virshrm() {
2107 for x in "$@"; do virsh destroy "$x"; virsh undefine "$x"; done
2108 }
2109
2110 vm-set-listen(){
2111 local t
2112 t=$(mktemp)
2113 local vm=$1
2114 local ip=$2
2115 sudo virsh dumpxml $vm | sed -r "s/(<listen.*address=')([^']+)/\1$ip/" | \
2116 sed -r "s/listen='[^']+/listen='$ip/"> $t
2117 sudo virsh undefine $vm
2118 sudo virsh define $t
2119 }
2120
2121
2122 vmshare() {
2123 vm-set-listen $1 0.0.0.0
2124 }
2125
2126
2127 vmunshare() {
2128 vm-set-listen $1 127.0.0.1
2129 }
2130
2131 myiwscan() {
2132 # find input, copy to pattern space, when we find the first field, print the copy in different order without newlines.
2133 # instead of using labels, we could just match a line and group, eg: /signal:/,{s/signal:(.*)/\1/h}
2134 sudo iw dev wls1 scan | sed -rn "
2135 s/^\Wcapability: (.*)/\1/;Ta;h;b
2136 :a;s/^\Wsignal: -([^.]+).*/\1/;Tb;H;b
2137 # padded to min width of 20
2138 :b;s/\WSSID: (.*)/\1 /;T;s/^(.{20}(.*[^ ])?) */\1/;H;g;s/(.*)\n(.*)\n(.*)/\2 \3 \1/gp;b
2139 "|sort -r
2140 }
2141
2142 # * misc stuff
2143
2144
2145 if $use_color && type -p tput &>/dev/null; then
2146 term_bold="$(tput bold)"
2147 term_red="$(tput setaf 1)"
2148 term_green="$(tput setaf 2)"
2149 term_yellow="$(tput setaf 3)"
2150 term_purple="$(tput setaf 5)"
2151 term_nocolor="$(tput sgr0)" # no font attributes
2152
2153 # unused so far. commented for shellcheck
2154 # term_underl="$(tput smul)"
2155 # term_blue="$(tput setaf 4)"
2156 # term_cyan="$(tput setaf 6)"
2157 fi
2158 # Try to keep environment pollution down, EPA loves us.
2159 unset safe_term match_lhs use_color
2160
2161 # * prompt
2162
2163
2164 if [[ $- == *i* ]]; then
2165
2166
2167 case $HOSTNAME in
2168 bk|je|li)
2169 if [[ $EUID == 1000 ]]; then
2170 system-status _ ||:
2171 fi
2172 ;;
2173 esac
2174
2175
2176 # this needs to come before next ps1 stuff
2177 # this stuff needs bash 4, feb 2009,
2178 # old enough to no longer condition on $BASH_VERSION anymore
2179 shopt -s autocd
2180 shopt -s dirspell
2181 PS1='\w'
2182 if [[ $- == *i* ]] && [[ ! $LC_INSIDE_EMACS ]]; then
2183 PROMPT_DIRTRIM=2
2184 bind -m vi-command B:shell-backward-word
2185 bind -m vi-command W:shell-forward-word
2186 fi
2187
2188 if [[ $SSH_CLIENT || $SUDO_USER ]]; then
2189 unset PROMPT_DIRTRIM
2190 PS1="\h:$PS1"
2191 fi
2192
2193 # emacs terminal has problems if this runs slowly,
2194 # so I've thrown a bunch of things at the wall to speed it up.
2195 prompt-command() {
2196 local return=$? # this MUST COME FIRST
2197 local ps_char ps_color
2198 unset IFS
2199
2200 if [[ $HISTFILE ]]; then
2201 history -a # save history
2202 fi
2203
2204 # assigned in brc2
2205 # shellcheck disable=SC1303
2206 if [[ $jr_pid ]]; then
2207 if [[ -e /proc/$jr_pid ]]; then
2208 kill $jr_pid
2209 fi
2210 unset jr_pid
2211 fi
2212
2213 case $return in
2214 0) ps_color="$term_purple"
2215 ps_char='\$'
2216 ;;
2217 *) ps_color="$term_green"
2218 ps_char="$return \\$"
2219 ;;
2220 esac
2221 if [[ ! -O . ]]; then # not owner
2222 if [[ -w . ]]; then # writable
2223 ps_color="$term_bold$term_red"
2224 else
2225 ps_color="$term_bold$term_green"
2226 fi
2227 fi
2228
2229 # faster than sourceing the file im guessing
2230 if [[ -e /dev/shm/iank-status && ! -e /tmp/quiet-status ]]; then
2231 eval $(< /dev/shm/iank-status)
2232 fi
2233 if [[ $MAIL_HOST && $MAIL_HOST != "$HOSTNAME" ]]; then
2234 ps_char="@ $ps_char"
2235 fi
2236 # We could test if sudo is active with sudo -nv
2237 # but then we get an email and log of lots of failed sudo commands.
2238 # We could turn those off, but seems better not to.
2239 if [[ $EUID != 0 ]] && [[ $DID_SUDO ]]; then
2240 psudo="\[$term_bold$term_red\]s\[$term_nocolor\] "
2241 fi
2242 if [[ ! $HISTFILE ]]; then
2243 ps_char="NOHIST $ps_char"
2244 fi
2245 PS1="${PS1%"${PS1#*[wW]}"} $psudo\[$ps_color\]$ps_char\[$term_nocolor\] "
2246
2247 # set titlebar. instead, using more advanced
2248 # titelbar below
2249 #echo -ne "$_title_escape $HOSTNAME ${PWD/#$HOME/~} \007"
2250 }
2251 PROMPT_COMMAND=prompt-command
2252
2253 if [[ $TERM == screen* ]]; then
2254 _title_escape="\033]..2;"
2255 else
2256 # somme sites recommend this, i dunno what the diff is.
2257 #_title_escape="\033]30;"
2258 _title_escape="\033]0;"
2259 fi
2260
2261 settitle () {
2262 # this makes it so we show the current command if
2263 # one is running, otherwise, show nothing
2264
2265 if [[ $1 == prompt-command ]]; then
2266 return 0
2267 fi
2268 if (( ${#BASH_ARGC[@]} == 1 && BASH_SUBSHELL == 0 )); then
2269 echo -ne "$_title_escape ${PWD/#$HOME/~} "
2270 printf "%s" "$*"
2271 echo -ne "\007"
2272 fi
2273 }
2274
2275 # note, this wont work:
2276 # x=$(mktemp); cp a $x
2277 # I havnt figured out why, bigger fish to fry.
2278 #
2279 # for titlebar.
2280 # condition from the screen man page i think.
2281 # note: duplicated in tx()
2282 if [[ $TERM == *(screen*|xterm*|rxvt*) ]]; then
2283 trap 'settitle "$BASH_COMMAND"' DEBUG
2284 else
2285 trap DEBUG
2286 fi
2287
2288 fi
2289
2290 # * stuff that makes sense to be at the end
2291
2292
2293 # best practice
2294 unset IFS
2295
2296 # shellcheck disable=SC1090
2297 [[ -s "$HOME/.rvm/scripts/rvm" ]] && source "$HOME/.rvm/scripts/rvm" # Load RVM into a shell session *as a function*
2298
2299 # I had this idea to start a bash shell which would run an initial
2300 # command passed through this env variable, then continue on
2301 # interactively. But the use case I had in mind went away.
2302 #
2303 # if [[ $MY_INIT_CMD ]]; then
2304 # "${MY_INIT_CMD[@]}"
2305 # unset MY_INIT_CMD
2306 # fi
2307
2308 # ensure no bad programs appending to this file will have an affect
2309 return 0